import java.sql.*;

public class CompareMetaData {
	private DiagnosticTest diagT;
	private SingleClientTest scT;
	private MultipleClientTest mcT;
	private String regOne;
	private String regTwo;
	private dbConnection dbCon;
	private String[] clientList1;
	private String[] clientList2;
	
	public CompareMetaData(){
		diagT = new DiagnosticTest();
		scT = new SingleClientTest();
		mcT = new MultipleClientTest();
		regOne = new String();
		regTwo = new String();
		dbCon = new dbConnection();
	}
	
	public CompareMetaData(String reg1, String reg2){
		diagT = new DiagnosticTest();
		scT = new SingleClientTest();
		mcT = new MultipleClientTest();
		dbCon = new dbConnection();
		regOne = reg1;
		regTwo = reg2;
		
		setClientLists();
		
	}	
	
	private void setClientLists() {
		// TODO Auto-generated method stub
	ResultSet rs,rs1;
		
		String cmd = "Select distinct client_name from benchmark_perf_info where entry_name =\"" +
		 	regOne + "\" and client_name != \"NULL\"";
		rs = dbCon.createExecuteQuery(cmd);

		cmd = "Select count(distinct client_name) from benchmark_perf_info where entry_name =\"" +
		regOne + "\" and client_name != \"NULL\"";
		rs1 = dbCon.createExecuteQuery(cmd);
		int i=0;
		try{
			int numClients=0;
			while(rs1 != null && rs1.next()){
				numClients = rs1.getInt(1);
				clientList1 = new String [numClients];
			}
			while(rs!=null && rs.next()){
       
				clientList1[i] = rs.getString("client_name");
				System.out.println("client Name->" + clientList1[i] + "position" + i);
				i++;
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}
		
		cmd = "Select distinct client_name from benchmark_perf_info where entry_name =\"" +
	 	regTwo + "\" and client_name != \"NULL\"";
		rs = dbCon.createExecuteQuery(cmd);

		cmd = "Select count(distinct client_name) from benchmark_perf_info where entry_name =\"" +
		regTwo + "\" and client_name != \"NULL\"";
		rs1 = dbCon.createExecuteQuery(cmd);
		i=0;
		try{
			int numClients=0;
			while(rs1 != null && rs1.next()){
			numClients = rs1.getInt(1);
			clientList2 = new String [numClients];
			}
			while(rs!=null && rs.next()){
   
			clientList2[i] = rs.getString("client_name");
			System.out.println("client Name->" + clientList2[i] + "position" + i);
			i++;
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public String[] getClientList1(){
		return clientList1;
	}

	public String[] getClientList2(){
		return clientList2;
	}
	
	public void compare(){
		ResultSet regRs1;
		ResultSet regRs2;
		RunRegression rr1;
		RunRegression rr2;
		
		String cmd = "Select * from config_info where entry_name  = \"" + regOne +"\"";
		//System.out.println(cmd);
		String cmd2 = "Select * from config_info where entry_name  = \"" + regTwo +"\"";
		//System.out.println(cmd2);
		//System.out.println("Comparing.....");
		regRs1 = dbCon.createExecuteQuery(cmd);
		regRs2 = dbCon.createExecuteQuery(cmd2);
		//System.out.println("Parsing.....");
		rr1 = parseResultSet(regRs1);
		System.out.println(regOne + " " +  rr1.getSingleClientTest().getRunLargeFileTest());
		rr2 = parseResultSet(regRs2);
		
		System.out.println(regTwo + " " +  rr2.getSingleClientTest().getRunLargeFileTest());
		//System.out.println("getting Final Results.....");
		getFinalComparison(rr1, rr2);
	}
	
	private void getFinalComparison(RunRegression rr1, RunRegression rr2){
		compareDiag(rr1.getDiagnosticTest(), rr2.getDiagnosticTest());
		compareSingleClientTest(rr1.getSingleClientTest(), rr2.getSingleClientTest());
		compareMultipleClientTest(rr1.getMultipleClientTest(), rr2.getMultipleClientTest());
	}
	
	private void compareMultipleClientTest(MultipleClientTest mct1, MultipleClientTest mct2){

		mcT.setRunMultipleClientTest(mct1.getRunMultipleClientsTest() 
				& mct2.getRunMultipleClientsTest());
		if(mcT.getRunMultipleClientsTest() == true){
			if((mct1.getMinFileSize() >= mct2.getMinFileSize())){
				mcT.setMinFileSize(mct1.getMinFileSize());
			}
			else{
				mcT.setMinFileSize(mct2.getMinFileSize());
			}
			
			if(mct1.getMaxFileSize() <= mct2.getMaxFileSize()){
				mcT.setMaxFileSize(mct1.getMaxFileSize());
			}
			else{
				mcT.setMaxFileSize(mct2.getMaxFileSize());
			}
			if(mct1.getMinRecordSize() >=mct2.getMinRecordSize()){
				mcT.setMinRecordSize(mct1.getMinRecordSize());
			}
			else{
				mcT.setMinRecordSize(mct1.getMinRecordSize());
			}
			if (mct1.getMaxRecordSize() <=mct2.getMaxRecordSize()){
				mcT.setMaxRecordSize(mct1.getMaxRecordSize());
			}
			else{
				mcT.setMaxRecordSize(mct2.getMaxRecordSize());
			}
			
				if(mct1.getMaxNumberOfClients() >= mct2.getMaxNumberOfClients()){
					mcT.setMaxNumberOfClients(mct2.getMaxNumberOfClients());
				}
				else{
					mcT.setMaxNumberOfClients(mct1.getMaxNumberOfClients());
				}
				if(mct1.getMinNumberOfClients() >= mct2.getMinNumberOfClients()){
					mcT.setMinNumberOfClients(mct1.getMinNumberOfClients());
				}
				else{
					mcT.setMinNumberOfClients(mct2.getMinNumberOfClients());
				}
			
		}
		else{
			mcT.setRunMultipleClientTest(false);
		}
	}
	
	private void compareSingleClientTest(SingleClientTest sct1, SingleClientTest sct2){
		scT.setRunSingleClientTest(sct1.getRunSingleClientTest() & sct2.getRunSingleClientTest());
		scT.setAutoReportTest(sct1.getAutoReportTest() & sct2.getAutoReportTest());
		scT.setRunLargeFileTest(sct1.getRunLargeFileTest() & sct2.getRunLargeFileTest());
		System.out.println( sct1.getRunLargeFileTest() + " " + sct2.getRunLargeFileTest());
		if(scT.getRunLargeFileTest() == true){
			if(sct1.getMinLargeFileSize() >= sct2.getMinLargeFileSize()){
				scT.setMinLargeFileSize(sct1.getMinLargeFileSize());
			}
			else{
				scT.setMinLargeFileSize(sct2.getMinLargeFileSize());
			}
			if(sct1.getMaxLargeFileSize() >= sct2.getMaxLargeFileSize()){
				scT.setMaxLargeFileSize(sct2.getMaxLargeFileSize());
			}
			else{
				scT.setMaxLargeFileSize(sct1.getMaxLargeFileSize());
			}
			if(sct1.getLargeFileRecordSize() == sct2.getLargeFileRecordSize()){
				scT.setLargeFileRecordSize(sct1.getLargeFileRecordSize());
			}
			else{
				scT.setRunLargeFileTest(false);
			}
			System.out.println("The min File size = " + scT.getMinLargeFileSize() );
		}
		scT.setRunSmallFileTest(sct1.getRunSmallFileTest() & sct2.getRunSmallFileTest());
		if(scT.getRunSmallFileTest() == true){
			if(sct1.getMinSmallFileSize() >= sct2.getMinSmallFileSize()){
				scT.setMinSmallFileSize(sct1.getMinSmallFileSize());
			}
			else{
				scT.setMinSmallFileSize(sct2.getMinSmallFileSize());
			}
			if(sct1.getMaxSmallFileSize() >= sct2.getMaxSmallFileSize()){
				scT.setMaxSmallFileSize(sct2.getMaxSmallFileSize());
			}
			else{
				scT.setMaxSmallFileSize(sct1.getMaxSmallFileSize());
			}
			
			if(sct1.getSmallFileRecordSize() == sct2.getSmallFileRecordSize()){
				scT.setSmallFileRecordSize(sct1.getSmallFileRecordSize());
			}
			else{
				scT.setRunSmallFileTest(false);
			}
			
		}
		
	}
	
	private void compareDiag(DiagnosticTest dg1, DiagnosticTest dg2){
		diagT.setRunDiagnostic(dg1.getRunDiagnostic() & dg2.getRunDiagnostic());
		diagT.setRunDiskPerf(dg1.getRunDiskPerf() & dg2.getRunDiskPerf());
		diagT.setRuniPerf(dg1.getRuniPerf() & dg2.getRuniPerf());
		diagT.setRunNetSat(dg1.getRunNetSat() & dg2.getRunNetSat());
	}
	
	private RunRegression parseResultSet(ResultSet rs){
		RunRegression rr = new RunRegression();
		DiagnosticTest dg = new DiagnosticTest();
		SingleClientTest st = new SingleClientTest();
		MultipleClientTest mt = new MultipleClientTest();
		try{
			while(rs.next()){
				if(rs.getInt("stage_zero") == 1) {
					dg.setRunDiagnostic(true);
				}
				else {
					dg.setRunDiagnostic(true);
				}
				if(rs.getInt("disk_perf") == 1){
					dg.setRunDiskPerf(true);
				}
				else{
					dg.setRunDiskPerf(false);
				}
				if(rs.getInt("network_perf") == 1){
					dg.setRuniPerf(true);
				}
				else{
					dg.setRuniPerf(false);
				}
				if(rs.getInt("netSat") == 1){
					dg.setRunNetSat(true);
				}
				else{
					dg.setRunNetSat(false);
				}
				dg.setNumberOfRuns(rs.getInt("stageZero_num_runs"));
				
				
				
				// stage One
				if(rs.getInt("stage_one") == 1){
					rr.setRunStageOne(true);
				}
				else{
					rr.setRunStageOne(false);
				}
				if(rs.getInt("single_client") == 1){
					st.setRunSingleClientTest(true);
				}
				else{
					st.setRunSingleClientTest(false);
				}
				
				st.setNumberOfRuns(rs.getInt("singleClient_num_runs"));
				
				if(rs.getInt("autoreport") == 1){
					st.setAutoReportTest(true);
				}
				else{
					st.setAutoReportTest(false);
				}
				if(rs.getInt("large_files") == 1){
					st.setRunLargeFileTest(true);
				}
				else{
					st.setRunLargeFileTest(false);
				}
				
				st.setMaxLargeFileSize(rs.getDouble("max_largefile"));
				st.setMinLargeFileSize(rs.getDouble("min_largefile"));
				st.setLargeFileRecordSize(rs.getDouble("largefile_recordsize"));
				
				if(rs.getInt("small_files") == 1){
					st.setRunSmallFileTest(true);
				}
				else{
					st.setRunSmallFileTest(false);
				}
				st.setMinSmallFileSize(rs.getInt("min_smallfile"));
				st.setMaxSmallFileSize(rs.getInt("max_smallfile"));
				st.setSmallFileRecordSize(rs.getDouble("smallfile_recordsize"));
				
				if(rs.getInt("multiple_clients") == 1){
					mt.setRunMultipleClientTest(true);
				}
				else{
					mt.setRunMultipleClientTest(false);
				}
				mt.setNumberOfRuns(rs.getInt("multipleClient_num_runs"));
				mt.setMinNumberOfClients(rs.getInt("min_numclients"));
				mt.setMaxNumberOfClients(rs.getInt("max_numclients"));
				mt.setMinFileSize(rs.getDouble("min_multiclient_filesize"));
				mt.setMaxFileSize(rs.getDouble("max_multiclient_filesize"));
				mt.setMinRecordSize(rs.getDouble("multiclient_min_recordsize"));
				mt.setMaxRecordSize(rs.getDouble("multiclient_max_recordsize"));
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}
		
		rr.setDiagnosticTest(dg);
		rr.setMultipleClientTest(mt);
		rr.setSingleClientTest(st);
		
		return rr;
	}
	public DiagnosticTest getDiagnosticResults(){
		return diagT;
	}
	
	public SingleClientTest getSingleClientResults(){
		return scT;
	}
	
	public MultipleClientTest getMultipleCLientResults(){
		return mcT;
	}
	
	public String getRegOneName(){
		return regOne;
	}
	
	public String getRegTwoName(){
		return regTwo;
	}
	
}
