import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;


public class MyRunButton extends JButton implements ActionListener{
	private JButton button;
	private RunRegression myRegressionObj;
	private MyCheckBox stage0chkbx;
	private MyCheckBox stage1chkbx;
	private MyCheckBox netSatchkbx;
	private MyCheckBox diskperfchkbx;
	private MyCheckBox singleClientchkbx;
	private MyCheckBox multipleClientchkbx;
	private MyCheckBox iperfchkbx;
	private MyCheckBox autoReportchkbx;
	private MyCheckBox singleClientLargeFileChkbx;
	private MyCheckBox singleClientSmallFileChkbx;
	private MyComboBox minLargeFile;
	private MyComboBox maxLargeFile;
	private MyComboBox minSmallFile;
	private MyComboBox maxSmallFile;
	private MyTextField minnumberOfclients;
	private MyTextField maxnumberOfclients;
	private MyComboBox minRecordSize;
	private MyComboBox maxRecordSize;
	private MyComboBox multipleClientMinFileSize;
	private MyComboBox multipleClientMaxFileSize;
	private MyComboBox numberOfRunsStageZero;
	private MyComboBox numberOfRunsMultipleClient;
	private MyComboBox numberOfRunsSingleClient;
	private ConfigFileManager configFileManager;
	private ConfigFileDialog configFileDialog;
	private MyTextField nameOfRun;
	private MyComboBox singleClientLargeRecordSize;
	private MyComboBox singleClientSmallRecordSize;
	
	MyRunButton(String caption, MyCheckBox stage0, MyCheckBox stage1, 
				MyCheckBox netsat, MyCheckBox iperfBox, MyCheckBox diskperf,
				MyCheckBox singleClient, MyCheckBox multipleClient, MyCheckBox autoreport,
				MyCheckBox largeFile, MyCheckBox smallFile, MyComboBox mnLargeFile,
				MyComboBox mxLargeFile, MyComboBox mnSmallFile, MyComboBox mxSmallFile,
				MyTextField minnumclients, MyTextField maxnumclients, MyComboBox multipleminFileSize, 
				MyComboBox multiplemaxFileSize, MyComboBox mnrSize, MyComboBox mxrSize, 
				MyComboBox numRunsStageZero, MyComboBox numRunsSingleClient, 
				MyComboBox numRunsMultipleClients, ConfigFileDialog cfd, 
				MyTextField nameRun, MyComboBox singleclientLargeRecsz, MyComboBox singleclientSmallRecsz){
		button = new JButton(caption);
		button.addActionListener(this);
		myRegressionObj = new RunRegression();
		stage0chkbx = stage0;
		stage1chkbx = stage1;
		netSatchkbx = netsat;
		iperfchkbx = iperfBox;
		diskperfchkbx = diskperf;
		singleClientchkbx = singleClient;
		multipleClientchkbx = multipleClient;
		autoReportchkbx = autoreport;
		singleClientLargeFileChkbx = largeFile;
		singleClientSmallFileChkbx = smallFile;
		minLargeFile = mnLargeFile;
		maxLargeFile = mxLargeFile;
		minSmallFile = mnSmallFile;
		maxSmallFile = mxSmallFile;
		minnumberOfclients = minnumclients;
		maxnumberOfclients = maxnumclients;
		minRecordSize = mnrSize;
		maxRecordSize = mxrSize;
		multipleClientMinFileSize = multipleminFileSize;
		multipleClientMaxFileSize = multiplemaxFileSize;
		numberOfRunsStageZero = numRunsStageZero;
		numberOfRunsSingleClient = numRunsSingleClient;
		numberOfRunsMultipleClient = numRunsMultipleClients;
		configFileDialog = cfd;
		nameOfRun = nameRun;
		singleClientLargeRecordSize = singleclientLargeRecsz;
		singleClientSmallRecordSize = singleclientSmallRecsz;
		//configFileManager = new ConfigFileManager();
	}

	public JButton getMyButton(){
		return button;
	}

	public void actionPerformed(ActionEvent e)
	{
			DiagnosticTest dg = new DiagnosticTest();
			SingleClientTest sct = new SingleClientTest();
			MultipleClientTest mct = new MultipleClientTest();
			String Error = new String("");
			boolean error = false;
			
			if(configFileDialog.getConfigFilePath().equals("")){
				error = true;
				Error = Error + "Enter Config File\n";
			}
			else{
				configFileManager = new ConfigFileManager(configFileDialog.getConfigFilePath());
			}
			
			if( nameOfRun.getLatestData().equals("")){
				error = true;
				Error = Error + "Enter the Name of the Run to save as. \n";
			}
			if(stage0chkbx.isSelected())
			{
				dg.setRunDiagnostic(true);
				dg.setRunNetSat(netSatchkbx.isSelected());
				dg.setRuniPerf(iperfchkbx.isSelected());
				dg.setRunDiskPerf(diskperfchkbx.isSelected());
				dg.setNumberOfRuns(numberOfRunsStageZero.getIndex() + 1);
			}
			else 
			{
				if(netSatchkbx.isSelected() || iperfchkbx.isSelected() || diskperfchkbx.isSelected())
				{
					error = true;
					Error = Error + "Diagnostic Phase Not Selected. Please select Diagnostic Phase. \n";
				}
				dg.setRunDiagnostic(false);
				dg.setRunNetSat(false);
				dg.setRuniPerf(false);
				dg.setRunDiskPerf(false);
			}
			
			if(stage1chkbx.isSelected())
			{
				myRegressionObj.setRunStageOne(true);
				if(singleClientchkbx.isSelected())
				{
					
					sct.setRunSingleClientTest(true);
					sct.setNumberOfRuns(numberOfRunsSingleClient.getIndex() + 1);
					sct.setAutoReportTest(autoReportchkbx.isSelected());
					sct.setRunLargeFileTest(singleClientLargeFileChkbx.isSelected());
					if(singleClientLargeFileChkbx.isSelected() && (minLargeFile.getIndex()  > maxLargeFile.getIndex())){
						error = true;
						Error = Error + "Min. Large File Size cannot be greater than Max. Large File. \n";
					}
					else{
						sct.setMaxLargeFileSize(Utils.convertFileSize(maxLargeFile.getIndex(), "512M"));
						sct.setMinLargeFileSize(Utils.convertFileSize(minLargeFile.getIndex(), "512M"));
						sct.setLargeFileRecordSize(Utils.convertFileSize(singleClientLargeRecordSize.getIndex(), "4K"));
					}
					sct.setRunSmallFileTest(singleClientSmallFileChkbx.isSelected());
					if(singleClientSmallFileChkbx.isSelected() && (minSmallFile.getIndex()  > maxSmallFile.getIndex())){
						error = true;
						Error = Error + "Min. Small File Size cannot be greater than Max. Small File. \n";
					}
					else{
						sct.setMaxSmallFileSize(Utils.convertFileSize(maxSmallFile.getIndex(), "64K"));
						sct.setMinSmallFileSize(Utils.convertFileSize(minSmallFile.getIndex(), "64K"));
						sct.setSmallFileRecordSize(Utils.convertFileSize(singleClientSmallRecordSize.getIndex(), "4K"));
					}
				}
				else
				{
					if(autoReportchkbx.isSelected() || singleClientLargeFileChkbx.isSelected() || singleClientSmallFileChkbx.isSelected())
					{
						error = true;
						Error = Error + "Single Client Test Not Selected. Please select Single Client Test.\n";
					}
					sct.setRunSingleClientTest(false);
					sct.setAutoReportTest(false);
					sct.setRunLargeFileTest(false);
					sct.setRunSmallFileTest(false);
					
				}
				if(multipleClientchkbx.isSelected())
				{
					mct.setRunMultipleClientTest(true);
					mct.setNumberOfRuns(numberOfRunsMultipleClient.getIndex() + 1);
					if(minnumberOfclients.getLatestData().equals("") == false)
					{
						try{
							int tempNumClients = Integer.parseInt(minnumberOfclients.getLatestData());
							if(tempNumClients <= configFileManager.getClients().size())
							{
								mct.setMinNumberOfClients(tempNumClients);
							}
							else
							{
								error = true;
								Error = Error + "min number of clients exceeds number of clients in config file \n";
							}
						}
						catch(NumberFormatException ex){
							error = true;
							Error = Error + "Min Number of clients should be a number \n";
						}
						
					}
					else
					{
						
						error = true;
						Error = Error + "Min Number of clients Field is empty \n";
					}
					if(maxnumberOfclients.getLatestData().equals("") == false)
					{
						try
						{
							int tempNumClients = Integer.parseInt(maxnumberOfclients.getLatestData());
							if(tempNumClients <= configFileManager.getClients().size())
							{
								mct.setMaxNumberOfClients(tempNumClients);
							}
							else
							{
								error = true;
								Error = Error + "max number of clients exceeds number of clients in config file \n";
							}
						}
						catch(NumberFormatException exp){
							error = true;
							Error = Error + "Max Number of clients should be a number \n";
						}
					}
					else
					{
						error = true;
						Error = Error + "Max Number of clients Field is empty \n";
					}
					if(mct.getMinNumberOfClients() > mct.getMaxNumberOfClients())
					{
						error = true;
						mct.setMinNumberOfClients(0);
						mct.setMaxNumberOfClients(0);
						Error = Error + "Min Number of clients cannot be greater than max number of clients \n";
					}
					if(minRecordSize.getIndex() <= maxRecordSize.getIndex())
					{
						mct.setMinRecordSize(Utils.convertFileSize(minRecordSize.getIndex(), "4K"));
						mct.setMaxRecordSize(Utils.convertFileSize(maxRecordSize.getIndex(), "4K"));
					}
					else
					{
						error = true;
						mct.setMinRecordSize(0);
						mct.setMaxRecordSize(0);
						Error = Error + "Min Record Size cannot be large than Max record Size \n";
					}
					
					if(multipleClientMaxFileSize.getIndex() >= multipleClientMinFileSize.getIndex())
					{
						mct.setMinFileSize(Utils.convertFileSize(multipleClientMinFileSize.getIndex(), "64K"));
						mct.setMaxFileSize(Utils.convertFileSize(multipleClientMaxFileSize.getIndex(), "64K"));
					}
					else
					{
						error = true;
						mct.setMinFileSize(0);
						mct.setMaxFileSize(0);
						Error = Error + "Multiple Client: Min File Size Cannot be larger than Max File Size \n";
					}
					
				}
				else 
				{
					if((maxnumberOfclients.getLatestData().equals("") == false) 
							|| (minnumberOfclients.getLatestData().equals("") == false)
							|| (minRecordSize.getIndex() > 1)
							|| (maxRecordSize.getIndex() > 1) 
							|| (multipleClientMinFileSize.getIndex() > 1)
							|| (multipleClientMaxFileSize.getIndex() > 1))
					{
						error = true;
						Error = Error + "Multiple Client Not Selected. Please select Multipe Client. \n";
					}
					mct.setRunMultipleClientTest(false);
				}
			}
			else {
				if(multipleClientchkbx.isSelected() || singleClientchkbx.isSelected() || autoReportchkbx.isSelected() 
							|| singleClientLargeFileChkbx.isSelected() || singleClientSmallFileChkbx.isSelected()){
					error = true;
					Error = Error + "Regression Phase Not Selected.Please select Regression Phase";
				}
				sct.setRunSingleClientTest(false);
				mct.setRunMultipleClientTest(false);
				myRegressionObj.setRunStageOne(false);
			}
			
			if(error){
					JOptionPane.showMessageDialog(this, Error, "Preg", JOptionPane.ERROR_MESSAGE);
			}
			else{
				myRegressionObj.setDiagnosticTest(dg);
				myRegressionObj.setMultipleClientTest(mct);
				myRegressionObj.setSingleClientTest(sct);
			//	int tempNumberofRuns = numberOfRuns.getIndex() + 1;
			//	myRegressionObj.setNumberOfRuns(tempNumberofRuns);
				myRegressionObj.setNameOfTheRun(nameOfRun.getLatestData());
				
				myRegressionObj.setConfigFileManager(configFileManager);
				myRegressionObj.runTest();
			}
	}	
	public void setDiagnostic(DiagnosticTest val){
		myRegressionObj.setDiagnosticTest(val);
	}
	
	public void setSingleClientTest(SingleClientTest val){
		myRegressionObj.setSingleClientTest(val);
	}
	
	public void setMultipleClientTest(MultipleClientTest val){
		myRegressionObj.setMultipleClientTest(val);
	}
	
	
}
