#!/bin/bash
# Description: This file is the diagnostic test script for 
# the pNFS regression suite and performance debugging tool chain. 
# Stage: 0 
# Author: Zainul Abedin (zja) & Swaroop Choudhari (svchoudh)
# Inputs: \
# Detailed Description: 
# Stage0 of the test suite is used to get Experimental setup information. 


export num_runs=$STAGE_ZERO_num_runs

# Check and see if disk performance diagnostics is required.
if [ $DISK_PERFORMANCE -ne 0 ]; then 
    echo "Running Disk performance diagnostics."
    disk_perf.sh
else
    echo "Disk performance disgnostics not required."
fi

# Check and see if raw network performance diagnostics is required.
if [ $RAW_NETWORK_PERFORMANCE -ne 0 ]; then
    echo "Running network performance diagnostics."
    network_performance.sh   
else
    echo "Network performance disgnostics not required."
fi

if [ $NET_SAT_PERFORMANCE -ne 0 ]; then 
    echo "Running Disk performance diagnostics."
    netSat_perf.sh
else
    echo "Disk performance disgnostics not required."
fi
